/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the SendMessageContext type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SendMessageContext{}

// SendMessageContext struct for SendMessageContext
type SendMessageContext struct {
	TransactionId *string `json:"transaction_id,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
	ActionId *string `json:"action_id,omitempty"`
	ScriptId *string `json:"script_id,omitempty"`
	// Canned response id
	CrId *string `json:"cr_id,omitempty"`
	Bgr *bool `json:"bgr,omitempty"`
}

// NewSendMessageContext instantiates a new SendMessageContext object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSendMessageContext() *SendMessageContext {
	this := SendMessageContext{}
	return &this
}

// NewSendMessageContextWithDefaults instantiates a new SendMessageContext object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSendMessageContextWithDefaults() *SendMessageContext {
	this := SendMessageContext{}
	return &this
}

// GetTransactionId returns the TransactionId field value if set, zero value otherwise.
func (o *SendMessageContext) GetTransactionId() string {
	if o == nil || IsNil(o.TransactionId) {
		var ret string
		return ret
	}
	return *o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendMessageContext) GetTransactionIdOk() (*string, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return o.TransactionId, true
}

// HasTransactionId returns a boolean if a field has been set.
func (o *SendMessageContext) HasTransactionId() bool {
	if o != nil && !IsNil(o.TransactionId) {
		return true
	}

	return false
}

// SetTransactionId gets a reference to the given string and assigns it to the TransactionId field.
func (o *SendMessageContext) SetTransactionId(v string) {
	o.TransactionId = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *SendMessageContext) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendMessageContext) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *SendMessageContext) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *SendMessageContext) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetActionId returns the ActionId field value if set, zero value otherwise.
func (o *SendMessageContext) GetActionId() string {
	if o == nil || IsNil(o.ActionId) {
		var ret string
		return ret
	}
	return *o.ActionId
}

// GetActionIdOk returns a tuple with the ActionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendMessageContext) GetActionIdOk() (*string, bool) {
	if o == nil || IsNil(o.ActionId) {
		return nil, false
	}
	return o.ActionId, true
}

// HasActionId returns a boolean if a field has been set.
func (o *SendMessageContext) HasActionId() bool {
	if o != nil && !IsNil(o.ActionId) {
		return true
	}

	return false
}

// SetActionId gets a reference to the given string and assigns it to the ActionId field.
func (o *SendMessageContext) SetActionId(v string) {
	o.ActionId = &v
}

// GetScriptId returns the ScriptId field value if set, zero value otherwise.
func (o *SendMessageContext) GetScriptId() string {
	if o == nil || IsNil(o.ScriptId) {
		var ret string
		return ret
	}
	return *o.ScriptId
}

// GetScriptIdOk returns a tuple with the ScriptId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendMessageContext) GetScriptIdOk() (*string, bool) {
	if o == nil || IsNil(o.ScriptId) {
		return nil, false
	}
	return o.ScriptId, true
}

// HasScriptId returns a boolean if a field has been set.
func (o *SendMessageContext) HasScriptId() bool {
	if o != nil && !IsNil(o.ScriptId) {
		return true
	}

	return false
}

// SetScriptId gets a reference to the given string and assigns it to the ScriptId field.
func (o *SendMessageContext) SetScriptId(v string) {
	o.ScriptId = &v
}

// GetCrId returns the CrId field value if set, zero value otherwise.
func (o *SendMessageContext) GetCrId() string {
	if o == nil || IsNil(o.CrId) {
		var ret string
		return ret
	}
	return *o.CrId
}

// GetCrIdOk returns a tuple with the CrId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendMessageContext) GetCrIdOk() (*string, bool) {
	if o == nil || IsNil(o.CrId) {
		return nil, false
	}
	return o.CrId, true
}

// HasCrId returns a boolean if a field has been set.
func (o *SendMessageContext) HasCrId() bool {
	if o != nil && !IsNil(o.CrId) {
		return true
	}

	return false
}

// SetCrId gets a reference to the given string and assigns it to the CrId field.
func (o *SendMessageContext) SetCrId(v string) {
	o.CrId = &v
}

// GetBgr returns the Bgr field value if set, zero value otherwise.
func (o *SendMessageContext) GetBgr() bool {
	if o == nil || IsNil(o.Bgr) {
		var ret bool
		return ret
	}
	return *o.Bgr
}

// GetBgrOk returns a tuple with the Bgr field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendMessageContext) GetBgrOk() (*bool, bool) {
	if o == nil || IsNil(o.Bgr) {
		return nil, false
	}
	return o.Bgr, true
}

// HasBgr returns a boolean if a field has been set.
func (o *SendMessageContext) HasBgr() bool {
	if o != nil && !IsNil(o.Bgr) {
		return true
	}

	return false
}

// SetBgr gets a reference to the given bool and assigns it to the Bgr field.
func (o *SendMessageContext) SetBgr(v bool) {
	o.Bgr = &v
}

func (o SendMessageContext) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SendMessageContext) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.TransactionId) {
		toSerialize["transaction_id"] = o.TransactionId
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.ActionId) {
		toSerialize["action_id"] = o.ActionId
	}
	if !IsNil(o.ScriptId) {
		toSerialize["script_id"] = o.ScriptId
	}
	if !IsNil(o.CrId) {
		toSerialize["cr_id"] = o.CrId
	}
	if !IsNil(o.Bgr) {
		toSerialize["bgr"] = o.Bgr
	}
	return toSerialize, nil
}

type NullableSendMessageContext struct {
	value *SendMessageContext
	isSet bool
}

func (v NullableSendMessageContext) Get() *SendMessageContext {
	return v.value
}

func (v *NullableSendMessageContext) Set(val *SendMessageContext) {
	v.value = val
	v.isSet = true
}

func (v NullableSendMessageContext) IsSet() bool {
	return v.isSet
}

func (v *NullableSendMessageContext) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSendMessageContext(val *SendMessageContext) *NullableSendMessageContext {
	return &NullableSendMessageContext{value: val, isSet: true}
}

func (v NullableSendMessageContext) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSendMessageContext) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


